# Generated from railties-3.0.3.gem by gem2rpm -*- rpm-spec -*-
%global gem_name railties

%global download_path http://rubygems.org/downloads/


%global runtests 1

Summary: Tools for creating, working with, and running Rails applications
Name: rubygem-%{gem_name}
Version: 3.2.13
Release: 0%{?dist}
Group: Development/Languages
License: MIT
URL: http://www.rubyonrails.org
Source0: %{download_path}%{gem_name}-%{version}.gem
# ** Take LICENSE file from upstream. **
# wget --no-check-certificate https://github.com/rails/rails/raw/master/railties/MIT-LICENSE
Source1: http://github.com/rails/rails/raw/master/railties/MIT-LICENSE
# to get tests:
# git clone http://github.com/rails/rails.git && cd rails/railties/
# git checkout v3.2.13 && tar czvf railties-3.2.13-tests.tgz test/
Source2: railties-%{version}-tests.tgz
# Rails depends on RDoc ~> 3.4 and upstream doesn't look to go to change it :/
# https://github.com/rails/rails/issues/9634
Patch0: rubygem-railties-3.2.12-relax-rdoc-dependency.patch
# Let's keep Requires and BuildRequires sorted alphabeticaly
Requires: ruby(release)
Requires: ruby(rubygems)
Requires: rubygem(actionpack) = %{version}
Requires: rubygem(activesupport) = %{version}
Requires: rubygem(rake) >= 0.8.7
Requires: rubygem(rack-ssl) >= 1.3.2
Requires: rubygem(rack-ssl) < 1.4
Requires: rubygem(rdoc) >= 3.4
# RDoc dependency is relaxed for now. See %%{PATCH0}.
# Requires: rubygem(rdoc) < 4
Requires: rubygem(thor) >= 0.14.6
Requires: rubygem(thor) < 2.0
BuildRequires: rubygems-devel
BuildRequires: ruby(release)
%if 0%{?runtests}
BuildRequires: rubygem(actionpack) = %{version}
BuildRequires: rubygem(activerecord) = %{version}
BuildRequires: rubygem(activesupport) = %{version}
BuildRequires: rubygem(actionmailer) = %{version}
BuildRequires: rubygem(bundler)
BuildRequires: rubygem(minitest)
BuildRequires: rubygem(mocha)
BuildRequires: rubygem(rake) >= 0.8.7
BuildRequires: rubygem(rack-ssl) >= 1.3.2
BuildRequires: rubygem(rack-ssl) < 1.4
BuildRequires: rubygem(sqlite3)
BuildRequires: rubygem(thor) >= 0.14.6
BuildRequires: rubygem(thor) < 2.0
%endif
BuildArch: noarch
Provides: rubygem(%{gem_name}) = %{version}

%description
Rails internals: application bootup, plugins, generators, and rake tasks.
Railties is responsible to glue all frameworks together. Overall, it:
* handles all the bootstrapping process for a Rails application;
* manager rails command line interface;
* provides Rails generators core;

%package doc
Summary: Documentation for %{name}
Group: Documentation
Requires: %{name} = %{version}-%{release}

%description doc
This package contains documentation for %{name}.

%prep
%setup -q -c -T
mkdir -p .%{_bindir}
%gem_install -n %{SOURCE0}

pushd .%{gem_dir}
%patch0 -p1
popd

# May by only for v.3.0.3-6
#  
# Some stylesheet seems to be mistakingly marked as executable in the upstream
# source
find .%{gem_instdir} -name *.css -type f -perm /a+x -exec %{__chmod} -v 644 {} \;

%build

%install
mkdir -p %{buildroot}%{gem_dir}
mkdir -p %{buildroot}%{_bindir}
cp -a .%{gem_dir}/* %{buildroot}%{gem_dir}
cp -a .%{_bindir}/* %{buildroot}%{_bindir}

cp %{SOURCE1} %{buildroot}%{gem_instdir}

%check
%if 0%{?runtests}
# fake RAILS_FRAMEWORK_ROOT
ln -s %{gem_dir}/gems/activesupport-%{version}/ .%{gem_dir}/gems/activesupport
ln -s ${PWD}%{gem_instdir} .%{gem_dir}/gems/railties
touch .%{gem_dir}/gems/load_paths.rb
export RUBYOPT="-I${PWD}%{gem_dir}/gems/railties:${PWD}%{gem_dir}/gems/railties/lib:${PWD}%{gem_dir}/gems/railties/test -rrails/all"
export PATH="${PWD}%{gem_dir}/gems/railties/bin:$PATH"

pushd .%{gem_dir}/gems/railties
# extract tests
tar xzf %{SOURCE2}

# TODO: Test are not yet in the best state.
ruby -e 'Dir.glob("test/**/*_test.rb").each {|t| require t}' \
  | grep "822 tests, 2038 assertions, 73 failures, 299 errors, 0 skips"
popd
%endif

%files
%{_bindir}/rails
%dir %{gem_instdir}
%exclude %{gem_instdir}/.yardoc
%{gem_instdir}/bin
%{gem_libdir}
%exclude %{gem_cache}
%{gem_spec}
%doc %{gem_instdir}/MIT-LICENSE

%files doc
%doc %{gem_docdir}
%doc %{gem_instdir}/CHANGELOG.md
%doc %{gem_instdir}/guides
%doc %{gem_instdir}/README.rdoc

%changelog
* Sat Mar 09 2013 Vít Ondruch <vondruch@redhat.com> - 3.2.12-3
- Relax RDoc dependency.

* Fri Mar 08 2013 Vít Ondruch <vondruch@redhat.com> - 3.2.12-2
- Rebuild for https://fedoraproject.org/wiki/Features/Ruby_2.0.0

* Tue Feb 12 2013 Vít Ondruch <vondruch@redhat.com> - 3.2.12-1
- Update to Railties 3.2.12.

* Wed Jan 09 2013 Vít Ondruch <vondruch@redhat.com> - 3.2.11-1
- Update to Railties 3.2.11.

* Fri Jan 04 2013 Vít Ondruch <vondruch@redhat.com> - 3.2.10-1
- Update to Railties 3.2.10.

* Mon Aug 13 2012 Vít Ondruch <vondruch@redhat.com> - 3.2.8-1
- Update to Railties 3.2.8.

* Mon Jul 30 2012 Vít Ondruch <vondruch@redhat.com> - 3.2.7-1
- Update to Railties 3.2.7.

* Mon Jul 23 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 3.2.6-1
- Update to Railties 3.2.6.
- Move some files into -doc subpackage.
- Remove the unneeded %%defattr.
- Introduce %%check section (not running tests yet, as they are part of dependency loop).

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0.15-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Fri Jun 15 2012 Vít Ondruch <vondruch@redhat.com> - 3.0.15-1
- Update to Railties 3.0.15.

* Fri Jun 01 2012 Vít Ondruch <vondruch@redhat.com> - 3.0.13-1
- Update to Railties 3.0.13.

* Wed Feb 01 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 3.0.11-1
- Rebuilt for Ruby 1.9.3.
- Update to Railties 3.0.11.

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0.10-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Mon Aug 22 2011 Vít Ondruch <vondruch@redhat.com> - 3.0.10-1
- Update to Railties 3.0.10

* Thu Jul 21 2011 Vít Ondruch <vondruch@redhat.com> - 3.0.9-2
- Added missing RDoc dependency.

* Thu Jul 07 2011 Vít Ondruch <vondruch@redhat.com> - 3.0.9-1
- Update to Railties 3.0.9

* Mon Jun 27 2011  <mmorsi@redhat.com> - 3.0.5-2
- include fix for BZ #715385

* Tue Mar 29 2011 Vít Ondruch <vondruch@redhat.com> - 3.0.5-1
- Updated to Railties 3.0.5

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0.3-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Feb 02 2011  <Minnikhanov@gmail.com> - 3.0.3-7
- Fix Comment 11 #665560. https://bugzilla.redhat.com/show_bug.cgi?id=668090#c11
- Take LICENSE file from upstream.

* Mon Jan 31 2011  <Minnikhanov@gmail.com> - 3.0.3-6
- Fix Comment 9 #665560. https://bugzilla.redhat.com/show_bug.cgi?id=668090#c9
- Temporarily test suite is blocked.

* Thu Jan 27 2011  <Minnikhanov@gmail.com> - 3.0.3-5
- Fix Comment 7 #665560. https://bugzilla.redhat.com/show_bug.cgi?id=668090#c7 

* Tue Jan 25 2011  <Minnikhanov@gmail.com> - 3.0.3-4
- Fix Comment 5 #665560. https://bugzilla.redhat.com/show_bug.cgi?id=668090#c5 

* Mon Jan 24 2011  <Minnikhanov@gmail.com> - 3.0.3-3
- Fix Comment 3 #665560. https://bugzilla.redhat.com/show_bug.cgi?id=668090#c3 

* Sun Jan 23 2011  <Minnikhanov@gmail.com> - 3.0.3-2
- Fix Comment 1 #665560. https://bugzilla.redhat.com/show_bug.cgi?id=668090#c1 

* Fri Jan 07 2011  <Minnikhanov@gmail.com> - 3.0.3-1
- Initial package

